Index: Makefile
===================================================================
--- Makefile	(revision a09b75f4659ceac7d945ee656e73137c9f8d3e1e)
+++ Makefile	(revision c61b5cee2fc1805ae543e63dc45bd2e0acaccb3b)
@@ -523,6 +523,6 @@
 	classes/SortableObject.h
 tmp/classes/DelphesCscClusterFormula.$(ObjSuf): \
-		classes/DelphesCscClusterFormula.$(SrcSuf) \
-		classes/DelphesCscClusterFormula.h
+	classes/DelphesCscClusterFormula.$(SrcSuf) \
+	classes/DelphesCscClusterFormula.h
 tmp/classes/DelphesCylindricalFormula.$(ObjSuf): \
 	classes/DelphesCylindricalFormula.$(SrcSuf) \
@@ -762,5 +762,5 @@
 	modules/CscClusterId.h \
 	classes/DelphesClasses.h \
-  classes/DelphesFactory.h \
+	classes/DelphesFactory.h \
 	classes/DelphesCscClusterFormula.h \
 	external/ExRootAnalysis/ExRootClassifier.h \
Index: cards/delphes_card_CMS_CSCCluster.tcl
===================================================================
--- cards/delphes_card_CMS_CSCCluster.tcl	(revision a09b75f4659ceac7d945ee656e73137c9f8d3e1e)
+++ cards/delphes_card_CMS_CSCCluster.tcl	(revision c61b5cee2fc1805ae543e63dc45bd2e0acaccb3b)
@@ -5,6 +5,4 @@
 set ExecutionPath {
   ParticlePropagator
-
-
 
   ChargedHadronTrackingEfficiency
@@ -61,5 +59,4 @@
   CutBasedIDEfficiency
   ClusterEfficiency
-
 
   TreeWriter
@@ -414,8 +411,8 @@
   set InputArray Delphes/allParticles
   set OutputArray LLP
-  set DecayRegion 1
   # DecayRegion = 0: no cuts on decay region
   # DecayRegion = 1: select LLP that decays in CSC volume
   # DecayRegion = 2: select LLP that decays outside of calorimeters, for genMET calculation
+  set DecayRegion 1
   set RequireStatus false
   add PdgCode {1500001}
@@ -427,10 +424,9 @@
   set InputArray Delphes/allParticles
   set OutputArray LLP
-  set DecayRegion 0
-  set RequireStatus false
-
   # DecayRegion = 0: no cuts on decay region
   # DecayRegion = 1: select LLP that decays in CSC volume
   # DecayRegion = 2: select LLP that decays outside of calorimeters, for genMET calculation
+  set DecayRegion 0
+  set RequireStatus false
   add PdgCode {1500001}
 
@@ -1034,30 +1030,13 @@
 module TreeWriter TreeWriter {
 # add Branch InputArray BranchName BranchClass
-#add Branch Delphes/allParticles Particle GenParticle
-  #add Branch Delphes/stableParticles Particle GenParticle
-  #add Branch TrackMerger/tracks Track Track
-  #add Branch Calorimeter/towers Tower Tower
-
-  #add Branch HCal/eflowTracks EFlowTrack Track
-  #add Branch ECal/eflowPhotons EFlowPhoton Tower
-  #add Branch HCal/eflowNeutralHadrons EFlowNeutralHadron Tower
-
-  #add Branch GenJetFinder/jets GenJet Jet
-  #add Branch GenMissingET/momentum GenMissingET MissingET
-
-
+# add Branch Delphes/allParticles Particle GenParticle
 
   add Branch UniqueObjectFinder/jets Jet Jet
   add Branch UniqueObjectFinder/electrons Electron Electron
-  #add Branch UniqueObjectFinder/photons Photon Photon
   add Branch UniqueObjectFinder/muons Muon Muon
 
-  #add Branch FatJetFinder/jets FatJet Jet
-
   add Branch MissingET/momentum MissingET MissingET
-  #add Branch ScalarHT/energy ScalarHT ScalarHT
   add Branch llpFilter/LLP llp CscCluster
   add Branch CSCFilter/LLP Cscllp CscCluster
-
   add Branch ClusterEfficiency/cluster CscCluster CscCluster
 }
Index: classes/DelphesClasses.h
===================================================================
--- classes/DelphesClasses.h	(revision a09b75f4659ceac7d945ee656e73137c9f8d3e1e)
+++ classes/DelphesClasses.h	(revision c61b5cee2fc1805ae543e63dc45bd2e0acaccb3b)
@@ -163,6 +163,4 @@
   Float_t decayT;
 
-  Float_t ctau;
-
   static CompBase *fgCompare; //!
   const CompBase *GetCompare() const { return fgCompare; }
@@ -650,5 +648,4 @@
 {
 public:
-  Int_t NHits; //nCSC hits
   Float_t Eta; // eta of LLP
   Float_t Phi; // phi of LLP
@@ -660,7 +657,5 @@
   Float_t Ehad; // had energy of LLP
   Float_t Eem; // em energy of LLP
-
   Float_t pid; // LLP pid
-
   Float_t T; // LLP decay time-photon travel time
   Float_t X; // LLP decay x
@@ -668,6 +663,6 @@
   Float_t Z; //  LLP decay z
   Float_t R; //  LLP decay z
-  Float_t beta;
-  Float_t ctau;
+  Float_t beta; // LLP beta
+  Float_t ctau; //LLP ctau
 
 
Index: modules/TreeWriter.cc
===================================================================
--- modules/TreeWriter.cc	(revision a09b75f4659ceac7d945ee656e73137c9f8d3e1e)
+++ modules/TreeWriter.cc	(revision c61b5cee2fc1805ae543e63dc45bd2e0acaccb3b)
@@ -245,7 +245,4 @@
     entry->decayZ = DecayPosition.Z();
     entry->decayT = DecayPosition.T()* 1.0E-3 / c_light;
-    float beta = entry->P/momentum.E();
-    float gamma = 1./sqrt(1-beta*beta);
-    entry->ctau = sqrt(pow(entry->decayX-entry->X,2)+pow(entry->decayY-entry->Y,2)+pow(entry->decayZ-entry->Z,2))/(beta*gamma);// in millimeter
   }
 }
@@ -930,8 +927,4 @@
     entry->Phi = momentum.Phi();
 
-
-    // entry->Eta = position.Eta();
-    // entry->Phi = position.Phi();
-
     entry->PT = momentum.Pt(); // pt of LLP
     entry->Px = momentum.Px();// px of LLP
@@ -940,19 +933,15 @@
     entry->E = momentum.E(); // E of LLP
     entry->pid = candidate->PID; // LLP pid
-    entry->Eem = candidate->Eem; // LLP pid
-    entry->Ehad = candidate->Ehad; // LLP pid
+    entry->Eem = candidate->Eem; // LLP Eem
+    entry->Ehad = candidate->Ehad; // LLP Ehad
     Double_t beta = momentum.P()/momentum.E();
     Double_t gamma = 1.0/sqrt(1-beta*beta);
     Double_t decayDistance = sqrt(pow(position.X(),2)+pow(position.Y(),2)+pow(position.Z(),2)); // mm
     entry->beta = beta; // LLP pid
-    entry->ctau = decayDistance/(beta * gamma);; // LLP pid
-
-    // entry->T = (position.T()-sqrt(pow(position.X(),2)+pow(position.Y(),2)+pow(position.Z(),2)))* 1.0E-3 / c_light; // LLP decay time-photon travel time
-
+    entry->ctau = decayDistance/(beta * gamma); // LLP travel time in its rest frame
     entry->T = decayDistance*(1./beta-1)* 1.0E-3/c_light*1e9; // ns
     entry->X = position.X(); // LLP decay x
     entry->Y = position.Y(); //  LLP decay y
     entry->Z = position.Z(); //  LLP decay z
-    // entry->Size = 100;
   }
 }
